/* tmnb4d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static int n = 3;
    static int m = 15;
    static int limit = 100;
    static double x[3] = { -1.2,2.,0. };
    static double eps = 1e-5;
    static double est = 0.;

    /* System generated locals */
    double d__1;

    /* Local variables */
    extern int grad_c(), func_c();
    static int ierr;
    extern int mnb4d_c(int *, int *, double *, double *, double *, double *,
                       double *, int *, int *, double *, int *, U_fp, U_fp);
    static double f, g[3], h__[15];
    static int i__, kount;

    mnb4d_c(&n, &m, x, &f, g, &est, &eps, &limit, &ierr, h__, &kount,
            (U_fp)func_c, (U_fp)grad_c);

/* L1: */
        x[i__ - 1] = (d__1 = 1. - x[i__ - 1], abs(d__1));
    printf("\n %12.5e %12.5e %12.5e \n", x[0], x[1], x[2]);
    printf("\n %12.5e \n", f);
    printf("\n %5i \n", ierr);
    printf("\n %5i \n", kount);
    return 0;
} /* main */

int func_c(double *x, double *f, double *fe)
{
    /* System generated locals */
    double d__1, d__2, d__3, d__4;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    d__2 = (x[1] + x[2]) / 2.;
/* Computing 2nd power */
    d__1 = x[3] - d__2 * d__2;
/* Computing 2nd power */
    d__3 = 1. - x[1];
/* Computing 2nd power */
    d__4 = 1. - x[2];
    *f = d__1 * d__1 * 100. + d__3 * d__3 + d__4 * d__4;
    return 0;
} /* func_c */

int grad_c(double *x, double *g, double *ge, int *i0)
{
    static double s;

    /* Parameter adjustments */
    --g;
    --x;

    /* Function Body */
    s = (x[1] + x[2]) / 2.;
    g[3] = (x[3] - s * s) * 2.;
    s = -g[3] * s;
    g[1] = s + (x[1] - 1.) * 2.;
    g[2] = s + (x[2] - 1.) * 2.;
    return 0;
} /* grad_c */
